/* dir.h
 *Model 100 library for Small C 85
 *
 *Willard Goosey
 *goosey@sdc.org
 *5/15/2017
 */

//$Id: dir.h,v 1.7 2017/07/06 20:55:52 goosey Exp goosey $

/*the RAM directory is an array of these
 *DIRECTORY points to the start of these
 */

struct dir {
  unsigned char dir_flag;
  char *dir_start;
  char dir_name[8];  //not null terminated!
};

//dir_flag BITs

#define DIR_VALID 0x80
#define DIR_ASCII 0x40
#define DIR_ML    0x20
#define DIR_ROM   0x10
#define DIR_INVIS 0x08
#define DIR_OPEN  0x02
#define DIR_CLOSE 0xF8

//last 3 bits are reserved, file open, internal use only

//MAKFIL extension bytes
#define DIR_BA 0x80
#define DIR_DO 0xC0
#define DIR_CO 0xA0

/*sys vars already defined in m100vars.h
 *ENDOFDIR = 0xff this value in dir_flag means no more dir entries
 *****actually a define of &ENDDIR not a var
 *ENDDIR = ?? pointer to byte at 0x00ff
 *DIRECTORY = 0xf962 start of RAM file directory
 *FDIR = 0xf9ba points to first file in directory
 *DOSTART = 0xfbae start of .DO files
 *COSTART = 0xfbb0 start of .CO files
 *FILEEND = 0xf88c end of ram file storage
 */

