/*m100vars.h
 *Willard Goosey
 *goosey@sdc.org
 *3/22/2017
 */

/*$Id: m100vars.h,v 1.12 2017/08/16 00:59:02 goosey Exp goosey $*/

/*Model 100 system variables
 *exported as globals by small.lib
 *derived from m100.def
 */

extern char CSRY; //0xF639 cursor Y pos 1 byte 
extern char CSRX; //0xF63A cursor X pos 1 byte
extern char BEGLCD[]; //0xFE00 start of LCD screen image
extern char ENDLCD; //0xFF40 end of LCD screen image
extern char ALTLCD[]; //0xFFC0 start of alternate screen image
extern char ALTLCDE; //0xFDFF end of alternate screen image

extern char INBUF[]; //0xF685 input buffer, null terminated

#define FCTER 0x80
//function key table entry terminator this is also a global var, just
//not currently exported by this file.

extern char CSFKEY[]; //0x5B46 cold start function key table
extern char BASFKY[]; //0xF80A BASIC function key table

extern char FKCTRL; //0xF650 flag. 0=F-keys return string from system table
//80h = F-keys skip first 4 bytes, return whats left

extern char LBENBL; //0xFAAD flag ffh=enable label line else disable

extern char COMSTR[]; //0xF65B current STAT settings, 5 bytes not null terminated

extern char DIRECTORY[]; //0xF962 pointer to RAM file directory

extern unsigned char ENDDIR; //0xFF this val in byte 1 means no further entries
#define ENDOFDIR (&ENDDIR)  
/*unfortunately these labels all end up being 
 *treated as pointers, so ENDDIR is a pointer to 
 *the byte at 00ff. This define gets us to the
 *actual value 5/17/2017
 */		    

extern char FILNAM[]; //0xFC93 standard filename variable 8 bytes
                     /*not null terminated!*/
extern char FDIR[]; //0xF9BA points to first file in directory

extern char ADSCFILE[]; //0xffd9 standard file name buffer for 
//address/schedule. 8 bytes, null terminated

extern int STKTOP; //0xFB9D holds the beginning address of the stack

extern char PTIMER; //0xF657 Number of 6-second intervals before the m100 
//shuts itself off. 1 byte
//0=disable power-off timer

extern char POWERFLAG; //0xF932 0=do not shut off m100 1 byte

extern char PASTEPTR[]; //0xF88C points to paste buffer
			//paste buffer is null-terminated

extern char SHPRTPR[]; //0xF88A points to null-teriminated string returned by 
		       //   shft-print key 
		       //"llist\n" by default

extern char BRKDIS; //0xF650 store #0x80 here to disable the top row of keys 
//(Fx, print, arrows) 1 byte
//store 0h here to enable top row of keys

extern int MAXRAM; //0xF5EF top of user RAM
extern int HIMEM; //0xF5F4 top of free RAM, bottom of protected binary ram
extern int FREBAS; //0xF99A start fo free BASIC memory
extern char MAXFILE; //0xFC82 number of reserved file buffers
extern int NEXTTXT; //0xF9A5 address of next text file
extern int DOSTART; //0xFBAE start of DO files
extern int COSTART; //0xFBB0 start of CO files
extern int VARSTART; //0xFBB2 start of BASIC variable space
extern int ARRSTART; //0xFBB4 start of BASIC array space
extern int FRESTART; //0xFBB6 start of free memory
extern int FILEEND; //0xF88C end of RAM file storage
extern int SYSRAM; //0xFAC0  lowest address used by system
extern char HOOK[]; //0xFADA   RST7 hook table
extern char TRIGFLAG; //0xFF8E trigger findfreq() on high or low
extern char SOUNDFLAG; //0xFF44 echo cassette port out speaker 0=on
